using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using Heb.Model;
namespace Heb.DAL
{
    /// <summary>
    /// ռ¼ 
    /// </summary>
   public class DiaryEnterService
   {
       //dbHelp ݿʵ
       DBHelper dbHelp = new DBHelper();

       /// <summary>
       /// ѯеռ  ռǼ
       /// </summary>
       /// <returns>List<DiaryEnter></returns>
       public List<DiaryEnter> getAllDiaryEnter()
       {
           DataTable dt = dbHelp.ExecuteQueryProc("usp_diaryenter_select", null);
           //¼ļ¼С1,¼û
           if (dt.Rows.Count<1)
	      {
		    return null;
	      }
           //ݱõһ
           List<DiaryEnter> list = new List<DiaryEnter>();
           foreach (DataRow row in dt.Rows)
           {
               DiaryEnter dia = new DiaryEnter();
               dia._Balance = Convert.ToDecimal(row["Balance"]);
               dia._Category = row["Category"].ToString();
               dia._CreateTime = Convert.ToDateTime(row["CreateTime"]);
               dia._ID = Convert.ToInt32(row["ID"]);
               dia._IncomeOrExpense = row["IncomeOrExpense"].ToString();
               dia._Introduce = row["Introduce"].ToString();
               dia._Money = Convert.ToDecimal(row["Money"]);
               list.Add(dia);
           }
           return list;
       }
       /// <summary>
       ///   Ӱ
       /// </summary>
       /// <param name="CreateTime">ʱ</param>
       /// <param name="IncomeOrExpense">/֧</param>
       /// <param name="Money"></param>
       /// <param name="Category"></param>
       /// <param name="Introduce">˵</param>
       /// <param name="Balance"></param>
       /// <returns>int</returns>
       public int InsertDiaryEnter(DateTime CreateTime, string IncomeOrExpense, decimal Money, string Category, string Introduce, decimal Balance)
       {
          SqlParameter[]paras=new SqlParameter[]{
            new SqlParameter("@createTime",CreateTime),
            new SqlParameter("@incomeOrExpense",IncomeOrExpense),
            new SqlParameter("@money",Money),
            new SqlParameter("@category",Category),
            new SqlParameter("@introduce",Introduce),
            new SqlParameter("@balance",Balance)
          };
           //Ӱ
          int result = dbHelp.ExecuteNonQueryProc("usp_diaryenter_insert", paras);
           return result;
       }

       /// <summary>
       /// Id ɾһ
       /// </summary>
       /// <param name="id"></param>
       /// <returns></returns>
       public int DeleteDiaryEnterById(int id)
       {
           //ɾ
           SqlParameter[]paras=new SqlParameter[]{
            new SqlParameter("@ID",id)
           };
           int result = dbHelp.ExecuteNonQueryProc("usp_diaryenter_delete", paras);
           return result;
       }

      
       /// <summary>
       /// õݵһĩ
       /// </summary>
       /// <param name="id"></param>
       /// <returns></returns>
       public decimal EndMoney(int id)
       {
           string sql = string.Format("select top(1) Balance from DiaryEnter where ID<'{0}' order by ID desc",id);

           try
           { 
               //ѯ ֻһ һֵ
             DataTable dt=dbHelp.GetTable(sql);
             return Convert.ToDecimal(dt.Rows[0]["Balance"]);
           }
           catch
           {
               
               throw;
           }
          
            

       }

       //õĩ
       public decimal EndMoney()
       {
           string sql = "select top(1) Balance from DiaryEnter order by ID desc";

           try
           {
               //ѯ ֻһ һֵ
               DataTable dt = dbHelp.GetTable(sql);

               //ʼֵ һݶû ʼֵҪ
               if (dt.Rows.Count<1)
               {
                   return 0;
               }
               return Convert.ToDecimal(dt.Rows[0]["Balance"]);
           }
           catch
           {

               throw;
           }
       }

       /// <summary>
       /// ID,޸
       /// </summary>
       /// <param name="Id">ID</param>
       /// <param name="IncomeOrExpense">/֧</param>
       /// <param name="Money">Ǯ</param>
       /// <param name="Category"></param>
       /// <param name="Introduce">˵</param>
       /// <param name="Balance"></param>
       /// <returns></returns>
       public int UpdateDiaryEnterById(int Id,string IncomeOrExpense, decimal Money, string Category, string Introduce, decimal Balance)
       {
           SqlParameter[] paras = new SqlParameter[]{
            new SqlParameter("@id",Id),
            new SqlParameter("@incomeOrExpense",IncomeOrExpense),
            new SqlParameter("@money",Money),
            new SqlParameter("@category",Category),
            new SqlParameter("@introduce",Introduce),
            new SqlParameter("@balance",Balance)
          };
           //Ӱ
           int result = dbHelp.ExecuteNonQueryProc("usp_diaryenter_update", paras);
           return result;
       }

       /// <summary>
       ///  õId(larger than дLThan) ,û ֻҪ idǮ
       /// </summary>
       /// <returns></returns>
       public List<DiaryEnter> getDiaryLThanId(int id)
       {

           string sql = "select ID,Balance from DiaryEnter where id> " + id;
           DataTable dt= dbHelp.GetTable(sql);
           if (dt.Rows.Count<1)
           {
               // ¼,С1 ʾ,ûб
               return null;
           }
           else
           {

               List<DiaryEnter> list = new List<DiaryEnter>();
               //Ĵ,õеıIdĶļ
               foreach (DataRow row in dt.Rows)
               {
                   DiaryEnter dia = new DiaryEnter();
                  dia._Balance = Convert.ToDecimal(row["Balance"]);
                  dia._ID = Convert.ToInt32(row["ID"]);

                  list.Add(dia);
               }

               return list;
           }

       }


       /// <summary>
       /// ɾмһ¼ԺĴ 
       /// </summary>
       /// <param name="Id"></param>
       /// <param name="money"></param>
       /// <returns></returns>
       public int updateMoneyToCount(int Id,decimal balance)
       {
           string sql = string.Format("update DiaryEnter set Balance='{0}' where ID={1}",balance,Id);
           //ִгɹ1 ʧܷ0
           return dbHelp.ExecuteNonQuery(sql)?1:0;
       }
   } 
}
