﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Heb.Model;
using System.Collections.Generic;
using Newtonsoft.Json;
/// <summary>
/// DiaryEnterJson 的摘要说明
/// </summary>
public class DiaryEnterJson
{
    public DiaryEnterJson()
    {
     
    }

    /// <summary>
    /// 把一个 List 序列化为一个 json数组 的字符串/>
    /// </summary>
    /// <param name="list"></param>
    /// <returns></returns>
    public string List2json(List<DiaryEnter>list)
    {
        if (list==null)
        {
            return "";
        }
        return JavaScriptConvert.SerializeObject(list); ;
    }

    /// <summary>
    /// 将 json字符串转换为一个集合
    /// </summary>
    /// <param name="strJson">参数 json字符串</param>
    /// <returns>返回一个日记集合</returns>
    public List<DiaryEnter> Json2DiaryEnterList(string strJson)
    {
        //得到的是一个对象
        List<DiaryEnter> list = new List<DiaryEnter>();
        foreach (JavaScriptObject item in (JavaScriptArray)JavaScriptConvert.DeserializeObject(strJson))
        {   
            DiaryEnter diary = new DiaryEnter();
            diary._ID = Convert.ToInt32(item["_ID"].ToString().Length>10?"0":item["_ID"]);
            diary._IncomeOrExpense = item["_IncomeOrExpense"].ToString();
            diary._Money = Convert.ToDecimal(item["_Money"]);
            diary._CreateTime = Convert.ToDateTime(item["_CreateTime"]);
            diary._Category = item["_Category"].ToString();
            diary._Balance = Convert.ToDecimal(item["_Balance"]);
            diary._Introduce = item["_Introduce"].ToString();
            list.Add(diary);
        }
        return list;
    }
}
