﻿// JScript 文件

        Ext.onReady(function () {
           alert("JS脚本执行了");
            Ext.QuickTips.init();

            function formatDate(value) {
                return value ? value.dateFormat('Y,M d') : '';
            };
            // shorthand alias
            var fm = Ext.form;

            // custom column plugin example
            var checkColumn = new Ext.grid.CheckColumn({
                header: "Indoor?",
                dataIndex: 'indoor',
                width: 55
            });

            // the column model has information about grid columns
            // dataIndex maps the column to the specific data field in
            // the data store (created below)
              // ID	CreateTime	IncomeOrExpense	Money	Category	Introduce	Balance
            var cm = new Ext.grid.ColumnModel([{
                id: 'ID',
                header: "编号",
                dataIndex: 'ID',
                width: 60
            }, {
                header: "日期",
                dataIndex: 'CreateTime',
                render:'',
                width: 200,
                editor: new fm.TextField({
                    allowBlank: false
                })
            }, {
                header: "收入/支出",
                dataIndex: 'IncomeOrExpense',
                width: 200,
                editor: new Ext.form.ComboBox({
                    typeAhead: true,
                    triggerAction: 'all',
                    transform: 'Money',
                    lazyRender: true,
                    listClass: 'x-combo-list-small'
                })
                
            }, {
                header: "金额",
                dataIndex: 'Money',
                width: 130,
                 editor: new fm.NumberField({
                    allowBlank: false,
                    allowNegative: false,
                    maxValue: 100000
                })
                
            }, {
                header: "分类",
                dataIndex: 'Category',
                width: 70,
                align: 'right',
                editor: new fm.TextField({
                    allowBlank: false
                })
               
            },{
                header: "说明",
                dataIndex: 'Introduce',
                width: 130,
                editor: new fm.TextField({
                    allowBlank: false
                })
//                editor: new Ext.form.ComboBox({
//                    typeAhead: true,
//                    triggerAction: 'all',
//                    transform: 'Introduce',
//                    lazyRender: true,
//                    listClass: 'x-combo-list-small'
//                })
            }, {
                header: "余额",
                dataIndex: 'Balance',
                width: 130,
                editor: new fm.NumberField({
                    allowBlank: false,
                    allowNegative: false,
                    maxValue: 100000
                })
            },{
                header: "操作",
                dataIndex: 'ID',
                width: 130
                
            },  
            {  //时间不做处理
                header: "Available",
                dataIndex: 'availDate',
                width: 95,
                renderer: formatDate,
                editor: new fm.DateField({
                    format: 'y/m/d/',
                    minValue: '06/01/01',
                    disabledDays: [0, 8],
                    disabledDaysText: 'Plants are not available on the weekends'
                })
            }
    ]);
            // by default columns are sortable
            cm.defaultSortable = true;
//// ID	CreateTime	IncomeOrExpense	Money	Category	Introduce	Balance
            // this could be inline, but we want to define the Plant record
            // type so we can add records dynamically
            var DiaryEnter = Ext.data.Record.create([
            // the "name" below matches the tag name to read, except "availDate"
            // which is mapped to the tag "availability"
            {name:'ID',type:'int'},
            {name:'CreateTime',type:'date',type: 'date', dateFormat: 'm/d/Y'},
            {name:'IncomeOrExpense',type:'string'},
            {name:'Money',type:'float'},
            {name:'Category',type:'string'},
            {name:'Introduce',type:'string'},
            {name:'Balance',type:'float'}
             ]);
       
           // 创建数据源
        var vproxy = new Ext.data.HttpProxy({
            url: 'DiarySource.aspx',
            reader: new Ext.data.JsonReader({
            // records will have a "plant" tag
            record: 'DiaryEnter'
           },DiaryEnter),
            sortInfo: { field: 'ID', direction: 'ASC' }
        });

        var store = new Ext.data.Store({
            proxy: vproxy
        });

        // 创建可编辑的表单
        var grid = new Ext.grid.EditorGridPanel({
            store: store,
            cm: cm,
            renderTo: 'editor-grid',
            width: 800,
            height: 300,
            autoExpandColumn: 'ID',
            title: '可编辑的表单',
            frame: true,
            plugins: checkColumn,
            clicksToEdit: 2,
            listeners: {
                "afterEdit": {
                    fn: afterEdit,
                    scope: this
                }
            },
            tbar: [{
                text: "保存",
                handler: function () {
                    var modified = store.modified;
                    updateData(modified);
                }
            }//增加一行 功能还有待实现
//            ,
//             {
//                text: '增加一行',
//                handler: function () {
//                    var p = new Plant({
//                        common: 'New Plant 1',
//                        botanical: 'Trillium grandiflorum',
//                        light: 'Mostly Shade',
//                        price: 0,
//                        availDate: (new Date()).clearTime(),
//                        indoor: false
//                    });
//                    grid.stopEditing();
//                    store.insert(0, p);
//                    grid.startEditing(0, 0);
//                }
//            }
            ]
        });

        // 触发数据加载
        store.load();
        ////--提交数据到后台
        function updateData(modified) {
            var json = [];
            Ext.each(modified, function (item) {
                json.push(item.data);
            });
            if (json.length > 0) {
                Ext.Ajax.request({
                    url: "DiarySource.aspx",
                    params: { data: Ext.util.JSON.encode(json) },
                    method: "POST",
                    success: function (response) {
                        Ext.Msg.alert("信息", "数据更新成功！", function () { store.reload(); });
                    },
                    failure: function (response) {
                        Ext.Msg.alert("警告", "数据更新失败，请稍后再试！");
                    }
                });
            }
            else {
                Ext.Msg.alert("警告", "没有任何需要更新的数据！");
            }
        }

        //编辑以后进行处理
        function afterEdit(e) {
           // alert("发现修改项");
            if (e.field == "common") {
                if (e.value == "大笨") {
                    Ext.Msg.alert("错误", "大笨是人物不是植物", function () { grid.startEditing(e.row, e.column) });
                }
            }
        }
        // ----编辑以后 触发afteredit事件
        grid.on("afteredit", afterEdit, grid);
    });

        Ext.grid.CheckColumn = function (config) {
            Ext.apply(this, config);
            if (!this.id) {
                this.id = Ext.id();
            }
            this.renderer = this.renderer.createDelegate(this);
        };

        Ext.grid.CheckColumn.prototype = {
            init: function (grid) {
                this.grid = grid;
                this.grid.on('render', function () {
                    var view = this.grid.getView();
                    view.mainBody.on('mousedown', this.onMouseDown, this);
                }, this);
            },
            onMouseDown: function (e, t) {
                if (t.className && t.className.indexOf('x-grid3-cc-' + this.id) != -1) {
                    e.stopEvent();
                    var index = this.grid.getView().findRowIndex(t);
                    var record = this.grid.store.getAt(index);
                    record.set(this.dataIndex, !record.data[this.dataIndex]);
                }
            },
            renderer: function (v, p, record) {
                p.css += ' x-grid3-check-col-td';
                return '<div class="x-grid3-check-col' + (v ? '-on' : '') + ' x-grid3-cc-' + this.id + '">&#160;</div>';
            }
        };





